<?php
namespace CodEntorSyntaxCreator;

use CodEntorSyntaxCreator\PageSettings\Page_Settings;
define('CodEntor_ACCORDION_PUBLIC_ASSETS_ALL', plugin_dir_url(__FILE__) . 'assets/public');
define('CodEntor_TEST_ASFSK_ASSETS_ADMIN_DIR_FILE', plugin_dir_url(__FILE__) . 'assets/admin');
class CodEntorSyntaxCreator {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function codentor_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'codentor_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function codentor_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'codentor_accordion_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/codentor-template.php' );
	}

	public function codentor_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files(); 

		// Register Widgets
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\CodEntor_Code_Widgete() );
	}

	private function add_page_settings_controls() {
		require_once( __DIR__ . '/page-settings/codentor-accordion-manager.php' );
		new Page_Settings();
	}

	// Register Category
	function codentor_add_elementor_widget_categories( $elements_manager ) {
		$elements_manager->add_category(
			'bwdthebest_general_category',
			[
				'title' => esc_html__( 'BWD General Group', CodEntor_TD ),
				'icon' => 'eicon-person',
			]
		);
	}
	public function codentor_all_assets_for_the_public(){
		wp_register_style( 'codentor-code-default', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-default.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-code-coy', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-coy.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-code-dark', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-dark.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-code-funky', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-funky.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-code-okaidia', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-okaidia.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-code-solarized-light', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-solarized-light.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-solarized-dark-atom', plugin_dir_url( __FILE__ ) . 'assets/public/css/solarized-dark-atom.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-code-tomorrow-night', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-tomorrow-night.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-code-twilight', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-twilight.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-code-toolbar', plugin_dir_url( __FILE__ ) . 'assets/public/css/prism-toolbar.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-cold-dark', plugin_dir_url( __FILE__ ) . 'assets/public/css/cold-dark.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-colddark-dark', plugin_dir_url( __FILE__ ) . 'assets/public/css/colddark-dark.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-z-touch', plugin_dir_url( __FILE__ ) . 'assets/public/css/z-touch.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-zonokai-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/zonokai-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-vs-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/vs-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-nord-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/nord-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-holy-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/holy-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-laserwave-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/laserwave-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-lucario-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/lucario-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-night-owl', plugin_dir_url( __FILE__ ) . 'assets/public/css/night-owl.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-atom-dark', plugin_dir_url( __FILE__ ) . 'assets/public/css/atom-dark.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-dracula-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/dracula-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-duotone-forest', plugin_dir_url( __FILE__ ) . 'assets/public/css/duotone-forest.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-duotone-dark', plugin_dir_url( __FILE__ ) . 'assets/public/css/duotone-dark.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-duotone-earth', plugin_dir_url( __FILE__ ) . 'assets/public/css/duotone-earth.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-duotone-light', plugin_dir_url( __FILE__ ) . 'assets/public/css/duotone-light.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-duotone-sea', plugin_dir_url( __FILE__ ) . 'assets/public/css/duotone-sea.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-duotone-space', plugin_dir_url( __FILE__ ) . 'assets/public/css/duotone-space.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-gruvbox-dark', plugin_dir_url( __FILE__ ) . 'assets/public/css/gruvbox-dark.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-gruvbox-light', plugin_dir_url( __FILE__ ) . 'assets/public/css/gruvbox-light.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-ghcolors-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/ghcolors-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-pojoaque', plugin_dir_url( __FILE__ ) . 'assets/public/css/pojoaque.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-shades-of-purple', plugin_dir_url( __FILE__ ) . 'assets/public/css/shades-of-purple.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-synthwave', plugin_dir_url( __FILE__ ) . 'assets/public/css/synthwave.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-a11y-dark-theme', plugin_dir_url( __FILE__ ) . 'assets/public/css/a11y-dark-theme.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-material-dark', plugin_dir_url( __FILE__ ) . 'assets/public/css/material-dark.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-material-light', plugin_dir_url( __FILE__ ) . 'assets/public/css/material-light.css', [], '1.0', 'all' );
		wp_register_style( 'codentor-material-oceanic', plugin_dir_url( __FILE__ ) . 'assets/public/css/material-oceanic.css', [], '1.0', 'all' );

		wp_register_script( 'codentor-code-prismjs', plugin_dir_url( __FILE__ ) . 'assets/public/js/prism.js', ['jquery'], '1.0', true );
		wp_register_script( 'codentor-code-toolbarjs', plugin_dir_url( __FILE__ ) . 'assets/public/js/prism-toolbar.js', ['jquery'], '1.0', true );
	}
	public function codentor_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
			'codentor-admin-icon' => array('codentor_path_admin_define'=>CodEntor_TEST_ASFSK_ASSETS_ADMIN_DIR_FILE . '/icon.css'),
		);
		foreach($all_css_js_file as $handle => $fileinfo){
			wp_enqueue_style( $handle, $fileinfo['codentor_path_admin_define'], null, '1.0', 'all');
		}
	}

	public function __construct() {
		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'codentor_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'codentor_all_assets_for_elementor_editor_admin']);

		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'codentor_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'codentor_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'codentor_admin_editor_scripts' ] );
		
		$this->add_page_settings_controls();
	}
}

// Instantiate Plugin Class
CodEntorSyntaxCreator::instance();
