<?php
namespace CodEntorSyntaxCreator\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use \Elementor\Plugin;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class CodEntor_Code_Widgete extends Widget_Base {

	public function get_name(){
		return esc_html__('CodEntorSyntaxHighlighter', CodEntor_TD );
	}

	public function get_title(){
		return esc_html__( 'CodEntor Syntax Highlighter', CodEntor_TD );
	}

	public function get_icon(){
		return 'codentor-accordion-icon eicon-code-highlight';
	}

	public function get_categories(){
		return [ 'bwdthebest_general_category' ];
	}

	public function get_style_depends(){
		return array('codentor-code-coy', 
			'codentor-code-dark', 
			'codentor-code-default', 
			'codentor-code-funky', 
			'codentor-code-okaidia', 
			'codentor-code-solarized-light', 
			'codentor-code-tomorrow-night', 
			'codentor-code-twilight',
			'codentor-cold-dark',
			'codentor-colddark-dark',
			'codentor-z-touch',
			'codentor-zonokai-theme',
			'codentor-vs-theme',
			'codentor-nord-theme',
			'codentor-holy-theme',
			'codentor-laserwave-theme',
			'codentor-lucario-theme',
			'codentor-night-owl',
			'codentor-atom-dark',
			'codentor-dracula-theme',
			'codentor-duotone-forest',
			'codentor-duotone-dark',
			'codentor-duotone-earth',
			'codentor-duotone-light',
			'codentor-duotone-sea',
			'codentor-duotone-space',
			'codentor-gruvbox-dark',
			'codentor-gruvbox-light',
			'codentor-ghcolors-theme',
			'codentor-a11y-dark-theme',
			'codentor-pojoaque',
			'codentor-shades-of-purple',
			'codentor-synthwave',
			'codentor-solarized-dark-atom',
			'codentor-material-dark',
			'codentor-material-light',
			'codentor-material-oceanic',
			'codentor-code-toolbar');
	}

	public function get_script_depends(){
		return array( 'codentor-code-prismjs', 'codentor-code-toolbarjs' );
	}

	protected function _register_controls(){

		$this->start_controls_section(
			'controls_section',
			[
				'label' => esc_html__( 'Code Syntex', CodEntor_TD ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'codentor_theme',
			[
				'label' => esc_html__( 'Theme Style', CodEntor_TD ),
				'type' => Controls_Manager::SELECT,
				'options' => [
					'Default' => esc_html__( 'Default', CodEntor_TD ),
					'Dark' => esc_html__( 'Dark', CodEntor_TD ),
					'Okaidia' => esc_html__( 'Okaidia', CodEntor_TD ),
					'Coy' => esc_html__( 'Coy', CodEntor_TD ),
					'Tomorrow Night' => esc_html__( 'Night', CodEntor_TD ),
					'Funky' => esc_html__( 'Funky', CodEntor_TD ),
					'Twilight' => esc_html__( 'Twilight', CodEntor_TD ),
					'Solarized Light' => esc_html__( 'Solarized Light', CodEntor_TD ),
					'Cold Dark' => esc_html__( 'Colddark Cold', CodEntor_TD ),
					'colddark-dark' => esc_html__( 'Colddark Dark', CodEntor_TD ),
					'z Touch' => esc_html__( 'Zeel Touch', CodEntor_TD ),
					'Zonokai Theme' => esc_html__( 'Zonokai Theme', CodEntor_TD ),
					'Vs Theme' => esc_html__( 'VS Theme', CodEntor_TD ),
					'Nord Theme' => esc_html__( 'Nord Theme', CodEntor_TD ),
					'Holy Theme' => esc_html__( 'Holy Theme', CodEntor_TD ),
					'Laserwave Theme' => esc_html__( 'Laserwave Theme', CodEntor_TD ),
					'Lucario Theme' => esc_html__( 'Lucario Theme', CodEntor_TD ),
					'Night Owl' => esc_html__( 'Night Owl', CodEntor_TD ),
					'Atom Dark' => esc_html__( 'Atom Dark', CodEntor_TD ),
					'Dracula Theme' => esc_html__( 'Dracula Theme', CodEntor_TD ),
					'Duotone-Forest' => esc_html__( 'Duotone Forest', CodEntor_TD ),
					'Duotone-Dark' => esc_html__( 'Duotone Dark', CodEntor_TD ),
					'Duotone-Earth' => esc_html__( 'Duotone Earth', CodEntor_TD ),
					'Duotone-Light' => esc_html__( 'Duotone Light', CodEntor_TD ),
					'Duotone-Sea' => esc_html__( 'Duotone Sea', CodEntor_TD ),
					'Duotone-Space' => esc_html__( 'Duotone Space', CodEntor_TD ),
					'A11y-Dark-Theme' => esc_html__( 'A11y Dark Theme', CodEntor_TD ),
					'gruvbox-dark' => esc_html__( 'Gruvbox Dark', CodEntor_TD ),
					'gruvbox-light' => esc_html__( 'Gruvbox Light', CodEntor_TD ),
					'ghcolors-theme' => esc_html__( 'Ghcolors Theme', CodEntor_TD ),
					'pojoaque' => esc_html__( 'Pojoaque', CodEntor_TD ),
					'shades-of-purple' => esc_html__( 'Shades Purple', CodEntor_TD ),
					'synthwave' => esc_html__( 'Synthwave', CodEntor_TD ),
					'solarized-dark-atom' => esc_html__( 'Solarized Dark Atom', CodEntor_TD ),
					'material-dark' => esc_html__( 'Material Dark', CodEntor_TD ),
					'material-light' => esc_html__( 'Material Light', CodEntor_TD ),
					'material-oceanic' => esc_html__( 'Material Oceanic', CodEntor_TD ),
				],
				'default' => 'Default'
			]
		);
		$this->add_control(
			'codentor_language',
			[
				'label' => esc_html__( 'Select Language', CodEntor_TD ),
				'type' => Controls_Manager::SELECT,
				'options' => [
					'none' => esc_html__( 'None', CodEntor_TD ),
					'abap' => esc_html__( 'abap', CodEntor_TD ),
					'abnf' => esc_html__( 'abnf', CodEntor_TD ),
					'actionscript' => esc_html__( 'actionscript', CodEntor_TD ),
					'ada' => esc_html__( 'ada', CodEntor_TD ),
					'adoc' => esc_html__( 'adoc', CodEntor_TD ),
					'agda' => esc_html__( 'agda', CodEntor_TD ),
					'al' => esc_html__( 'al', CodEntor_TD ),
					'antlr4' => esc_html__( 'antlr4', CodEntor_TD ),
					'apacheconf' => esc_html__( 'apacheconf', CodEntor_TD ),
					'apex' => esc_html__( 'apex', CodEntor_TD ),
					'apl' => esc_html__( 'apl', CodEntor_TD ),
					'applescript' => esc_html__( 'applescript', CodEntor_TD ),
					'aql' => esc_html__( 'aql', CodEntor_TD ),
					'arduino' => esc_html__( 'arduino', CodEntor_TD ),
					'arff' => esc_html__( 'arff', CodEntor_TD ),
					'asciidoc' => esc_html__( 'asciidoc', CodEntor_TD ),
					'asm6502' => esc_html__( 'asm6502', CodEntor_TD ),
					'aspnet' => esc_html__( 'aspnet', CodEntor_TD ),
					'atom' => esc_html__( 'atom', CodEntor_TD ),
					'autohotkey' => esc_html__( 'autohotkey', CodEntor_TD ),
					'autoit' => esc_html__( 'autoit', CodEntor_TD ),
					'bash' => esc_html__( 'bash', CodEntor_TD ),
					'basic' => esc_html__( 'basic', CodEntor_TD ),
					'batch' => esc_html__( 'batch', CodEntor_TD ),
					'bbcode' => esc_html__( 'bbcode', CodEntor_TD ),
					'birb' => esc_html__( 'birb', CodEntor_TD ),
					'bison' => esc_html__( 'bison', CodEntor_TD ),
					'bnf' => esc_html__( 'bnf', CodEntor_TD ),
					'brainfuck' => esc_html__( 'brainfuck', CodEntor_TD ),
					'brightscript' => esc_html__( 'brightscript', CodEntor_TD ),
					'bro' => esc_html__( 'bro', CodEntor_TD ),
					'bsl' => esc_html__( 'bsl', CodEntor_TD ),
					'c' => esc_html__( 'c', CodEntor_TD ),
					'cil' => esc_html__( 'cil', CodEntor_TD ),
					'clike' => esc_html__( 'clike', CodEntor_TD ),
					'clojure' => esc_html__( 'clojure', CodEntor_TD ),
					'cmake' => esc_html__( 'cmake', CodEntor_TD ),
					'coffee' => esc_html__( 'coffee', CodEntor_TD ),
					'coffeescript' => esc_html__( 'coffeescript', CodEntor_TD ),
					'conc' => esc_html__( 'conc', CodEntor_TD ),
					'concurnas' => esc_html__( 'concurnas', CodEntor_TD ),
					'context' => esc_html__( 'context', CodEntor_TD ),
					'cpp' => esc_html__( 'cpp', CodEntor_TD ),
					'crystal' => esc_html__( 'crystal', CodEntor_TD ),
					'cs' => esc_html__( 'cs', CodEntor_TD ),
					'csharp' => esc_html__( 'csharp', CodEntor_TD ),
					'csp' => esc_html__( 'csp', CodEntor_TD ),
					'css' => esc_html__( 'css', CodEntor_TD ),
					'cypher' => esc_html__( 'cypher', CodEntor_TD ),
					'd' => esc_html__( 'd', CodEntor_TD ),
					'dart' => esc_html__( 'dart', CodEntor_TD ),
					'dataweave' => esc_html__( 'dataweave', CodEntor_TD ),
					'dax' => esc_html__( 'dax', CodEntor_TD ),
					'DFS' => esc_html__( 'DFS', CodEntor_TD ),
					'dhall' => esc_html__( 'dhall', CodEntor_TD ),
					'diff' => esc_html__( 'diff', CodEntor_TD ),
					'django' => esc_html__( 'django', CodEntor_TD ),
					'dns-zone' => esc_html__( 'dns-zone', CodEntor_TD ),
					'dns-zone-file' => esc_html__( 'dns-zone-file', CodEntor_TD ),
					'docker' => esc_html__( 'docker', CodEntor_TD ),
					'dockerfile' => esc_html__( 'dockerfile', CodEntor_TD ),
					'dotnet' => esc_html__( 'dotnet', CodEntor_TD ),
					'ebnf' => esc_html__( 'ebnf', CodEntor_TD ),
					'editorconfig' => esc_html__( 'editorconfig', CodEntor_TD ),
					'eiffel' => esc_html__( 'eiffel', CodEntor_TD ),
					'ejs' => esc_html__( 'ejs', CodEntor_TD ),
					'elisp' => esc_html__( 'elisp', CodEntor_TD ),
					'elixir' => esc_html__( 'elixir', CodEntor_TD ),
					'elm' => esc_html__( 'elm', CodEntor_TD ),
					'emacs' => esc_html__( 'emacs', CodEntor_TD ),
					'emacs-lisp' => esc_html__( 'emacs-lisp', CodEntor_TD ),
					'erb' => esc_html__( 'erb', CodEntor_TD ),
					'erlang' => esc_html__( 'erlang', CodEntor_TD ),
					'eta' => esc_html__( 'eta', CodEntor_TD ),
					'etlua' => esc_html__( 'etlua', CodEntor_TD ),
					'excel-formula' => esc_html__( 'excel-formula', CodEntor_TD ),
					'extend' => esc_html__( 'extend', CodEntor_TD ),
					'factor' => esc_html__( 'factor', CodEntor_TD ),
					'firestore-security-rules' => esc_html__( 'firestore-security-rules', CodEntor_TD ),
					'flow' => esc_html__( 'flow', CodEntor_TD ),
					'fortran' => esc_html__( 'fortran', CodEntor_TD ),
					'fsharp' => esc_html__( 'fsharp', CodEntor_TD ),
					'ftl' => esc_html__( 'ftl', CodEntor_TD ),
					'g4' => esc_html__( 'g4', CodEntor_TD ),
					'gamemakerlanguage' => esc_html__( 'gamemakerlanguage', CodEntor_TD ),
					'gcode' => esc_html__( 'gcode', CodEntor_TD ),
					'gdscript' => esc_html__( 'gdscript', CodEntor_TD ),
					'gedcom' => esc_html__( 'gedcom', CodEntor_TD ),
					'gherkin' => esc_html__( 'gherkin', CodEntor_TD ),
					'git' => esc_html__( 'git', CodEntor_TD ),
					'gitignore' => esc_html__( 'gitignore', CodEntor_TD ),
					'glsl' => esc_html__( 'glsl', CodEntor_TD ),
					'gml' => esc_html__( 'gml', CodEntor_TD ),
					'go' => esc_html__( 'go', CodEntor_TD ),
					'graphql' => esc_html__( 'graphql', CodEntor_TD ),
					'groovy' => esc_html__( 'groovy', CodEntor_TD ),
					'haml' => esc_html__( 'haml', CodEntor_TD ),
					'handlebars' => esc_html__( 'handlebars', CodEntor_TD ),
					'haskell' => esc_html__( 'haskell', CodEntor_TD ),
					'haxe' => esc_html__( 'haxe', CodEntor_TD ),
					'hcl' => esc_html__( 'hcl', CodEntor_TD ),
					'hgignore' => esc_html__( 'hgignore', CodEntor_TD ),
					'hlsl' => esc_html__( 'hlsl', CodEntor_TD ),
					'hpkp' => esc_html__( 'hpkp', CodEntor_TD ),
					'hs' => esc_html__( 'hs', CodEntor_TD ),
					'hsts' => esc_html__( 'hsts', CodEntor_TD ),
					'html' => esc_html__( 'html', CodEntor_TD ),
					'http' => esc_html__( 'http', CodEntor_TD ),
					'ichigojam' => esc_html__( 'ichigojam', CodEntor_TD ),
					'icon' => esc_html__( 'icon', CodEntor_TD ),
					'iecst' => esc_html__( 'iecst', CodEntor_TD ),
					'ignore' => esc_html__( 'ignore', CodEntor_TD ),
					'inform7' => esc_html__( 'inform7', CodEntor_TD ),
					'ini' => esc_html__( 'ini', CodEntor_TD ),
					'insertBefore' => esc_html__( 'insertBefore', CodEntor_TD ),
					'io' => esc_html__( 'io', CodEntor_TD ),
					'j' => esc_html__( 'j', CodEntor_TD ),
					'java' => esc_html__( 'java', CodEntor_TD ),
					'javadoc' => esc_html__( 'javadoc', CodEntor_TD ),
					'javadoclike' => esc_html__( 'javadoclike', CodEntor_TD ),
					'javascript' => esc_html__( 'javascript', CodEntor_TD ),
					'javastacktrace' => esc_html__( 'javastacktrace', CodEntor_TD ),
					'jinja2' => esc_html__( 'jinja2', CodEntor_TD ),
					'jolie' => esc_html__( 'jolie', CodEntor_TD ),
					'jq' => esc_html__( 'jq', CodEntor_TD ),
					'js' => esc_html__( 'js', CodEntor_TD ),
					'jsdoc' => esc_html__( 'jsdoc', CodEntor_TD ),
					'json' => esc_html__( 'json', CodEntor_TD ),
					'json5' => esc_html__( 'json5', CodEntor_TD ),
					'jsonp' => esc_html__( 'jsonp', CodEntor_TD ),
					'jsstacktrace' => esc_html__( 'jsstacktrace', CodEntor_TD ),
					'jsx' => esc_html__( 'jsx', CodEntor_TD ),
					'julia' => esc_html__( 'julia', CodEntor_TD ),
					'keyman' => esc_html__( 'keyman', CodEntor_TD ),
					'kotlin' => esc_html__( 'kotlin', CodEntor_TD ),
					'kt' => esc_html__( 'kt', CodEntor_TD ),
					'kts' => esc_html__( 'kts', CodEntor_TD ),
					'latex' => esc_html__( 'latex', CodEntor_TD ),
					'latte' => esc_html__( 'latte', CodEntor_TD ),
					'less' => esc_html__( 'less', CodEntor_TD ),
					'lilypond' => esc_html__( 'lilypond', CodEntor_TD ),
					'liquid' => esc_html__( 'liquid', CodEntor_TD ),
					'lisp' => esc_html__( 'lisp', CodEntor_TD ),
					'livescript' => esc_html__( 'livescript', CodEntor_TD ),
					'llvm' => esc_html__( 'llvm', CodEntor_TD ),
					'lolcode' => esc_html__( 'lolcode', CodEntor_TD ),
					'lua' => esc_html__( 'lua', CodEntor_TD ),
					'ly' => esc_html__( 'ly', CodEntor_TD ),
					'makefile' => esc_html__( 'makefile', CodEntor_TD ),
					'markdown' => esc_html__( 'markdown', CodEntor_TD ),
					'markup' => esc_html__( 'markup', CodEntor_TD ),
					'markup-templating' => esc_html__( 'markup-templating', CodEntor_TD ),
					'mathml' => esc_html__( 'mathml', CodEntor_TD ),
					'matlab' => esc_html__( 'matlab', CodEntor_TD ),
					'md' => esc_html__( 'md', CodEntor_TD ),
					'mel' => esc_html__( 'mel', CodEntor_TD ),
					'mizar' => esc_html__( 'mizar', CodEntor_TD ),
					'mongodb' => esc_html__( 'mongodb', CodEntor_TD ),
					'monkey' => esc_html__( 'monkey', CodEntor_TD ),
					'moon' => esc_html__( 'moon', CodEntor_TD ),
					'moonscript' => esc_html__( 'moonscript', CodEntor_TD ),
					'mscript' => esc_html__( 'mscript', CodEntor_TD ),
					'n1ql' => esc_html__( 'n1ql', CodEntor_TD ),
					'n4js' => esc_html__( 'n4js', CodEntor_TD ),
					'n4jsd' => esc_html__( 'n4jsd', CodEntor_TD ),
					'nand2tetris-hdl' => esc_html__( 'nand2tetris-hdl', CodEntor_TD ),
					'nani' => esc_html__( 'nani', CodEntor_TD ),
					'naniscript' => esc_html__( 'naniscript', CodEntor_TD ),
					'nasm' => esc_html__( 'nasm', CodEntor_TD ),
					'neon' => esc_html__( 'neon', CodEntor_TD ),
					'nginx' => esc_html__( 'nginx', CodEntor_TD ),
					'nim' => esc_html__( 'nim', CodEntor_TD ),
					'nix' => esc_html__( 'nix', CodEntor_TD ),
					'npmignore' => esc_html__( 'npmignore', CodEntor_TD ),
					'nsis' => esc_html__( 'nsis', CodEntor_TD ),
					'objc' => esc_html__( 'objc', CodEntor_TD ),
					'objectivec' => esc_html__( 'objectivec', CodEntor_TD ),
					'objectpascal' => esc_html__( 'objectpascal', CodEntor_TD ),
					'ocaml' => esc_html__( 'ocaml', CodEntor_TD ),
					'opencl' => esc_html__( 'opencl', CodEntor_TD ),
					'oscript' => esc_html__( 'oscript', CodEntor_TD ),
					'oz' => esc_html__( 'oz', CodEntor_TD ),
					'parigp' => esc_html__( 'parigp', CodEntor_TD ),
					'parser' => esc_html__( 'parser', CodEntor_TD ),
					'pascal' => esc_html__( 'pascal', CodEntor_TD ),
					'pascaligo' => esc_html__( 'pascaligo', CodEntor_TD ),
					'pbfasm' => esc_html__( 'pbfasm', CodEntor_TD ),
					'pcaxis' => esc_html__( 'pcaxis', CodEntor_TD ),
					'pcode' => esc_html__( 'pcode', CodEntor_TD ),
					'peoplecode' => esc_html__( 'peoplecode', CodEntor_TD ),
					'perl' => esc_html__( 'perl', CodEntor_TD ),
					'php' => esc_html__( 'php', CodEntor_TD ),
					'phpdoc' => esc_html__( 'phpdoc', CodEntor_TD ),
					'plsql' => esc_html__( 'plsql', CodEntor_TD ),
					'powerquery' => esc_html__( 'powerquery', CodEntor_TD ),
					'powershell' => esc_html__( 'powershell', CodEntor_TD ),
					'pq' => esc_html__( 'pq', CodEntor_TD ),
					'processing' => esc_html__( 'processing', CodEntor_TD ),
					'prolog' => esc_html__( 'prolog', CodEntor_TD ),
					'promql' => esc_html__( 'promql', CodEntor_TD ),
					'properties' => esc_html__( 'properties', CodEntor_TD ),
					'protobuf' => esc_html__( 'protobuf', CodEntor_TD ),
					'pug' => esc_html__( 'pug', CodEntor_TD ),
					'puppet' => esc_html__( 'puppet', CodEntor_TD ),
					'pure' => esc_html__( 'pure', CodEntor_TD ),
					'purebasic' => esc_html__( 'purebasic', CodEntor_TD ),
					'purescript' => esc_html__( 'purescript', CodEntor_TD ),
					'purs' => esc_html__( 'purs', CodEntor_TD ),
					'px' => esc_html__( 'px', CodEntor_TD ),
					'py' => esc_html__( 'py', CodEntor_TD ),
					'python' => esc_html__( 'python', CodEntor_TD ),
					'q' => esc_html__( 'q', CodEntor_TD ),
					'qml' => esc_html__( 'qml', CodEntor_TD ),
					'qore' => esc_html__( 'qore', CodEntor_TD ),
					'r' => esc_html__( 'r', CodEntor_TD ),
					'racket' => esc_html__( 'racket', CodEntor_TD ),
					'rb' => esc_html__( 'rb', CodEntor_TD ),
					'rbnf' => esc_html__( 'rbnf', CodEntor_TD ),
					'reason' => esc_html__( 'reason', CodEntor_TD ),
					'regex' => esc_html__( 'regex', CodEntor_TD ),
					'renpy' => esc_html__( 'renpy', CodEntor_TD ),
					'rest' => esc_html__( 'rest', CodEntor_TD ),
					'rip' => esc_html__( 'rip', CodEntor_TD ),
					'rkt' => esc_html__( 'rkt', CodEntor_TD ),
					'roboconf' => esc_html__( 'roboconf', CodEntor_TD ),
					'robot' => esc_html__( 'robot', CodEntor_TD ),
					'robotframework' => esc_html__( 'robotframework', CodEntor_TD ),
					'rpy' => esc_html__( 'rpy', CodEntor_TD ),
					'rq' => esc_html__( 'rq', CodEntor_TD ),
					'rss' => esc_html__( 'rss', CodEntor_TD ),
					'ruby' => esc_html__( 'ruby', CodEntor_TD ),
					'rust' => esc_html__( 'rust', CodEntor_TD ),
					'sas' => esc_html__( 'sas', CodEntor_TD ),
					'sass' => esc_html__( 'sass', CodEntor_TD ),
					'scala' => esc_html__( 'scala', CodEntor_TD ),
					'scheme' => esc_html__( 'scheme', CodEntor_TD ),
					'scss' => esc_html__( 'scss', CodEntor_TD ),
					'sh-session' => esc_html__( 'sh-session', CodEntor_TD ),
					'shell' => esc_html__( 'shell', CodEntor_TD ),
					'shell-session' => esc_html__( 'shell-session', CodEntor_TD ),
					'shellsession' => esc_html__( 'shellsession', CodEntor_TD ),
					'shortcode' => esc_html__( 'shortcode', CodEntor_TD ),
					'sln' => esc_html__( 'sln', CodEntor_TD ),
					'smali' => esc_html__( 'smali', CodEntor_TD ),
					'smalltalk' => esc_html__( 'smalltalk', CodEntor_TD ),
					'smarty' => esc_html__( 'smarty', CodEntor_TD ),
					'sml' => esc_html__( 'sml', CodEntor_TD ),
					'smlnj' => esc_html__( 'smlnj', CodEntor_TD ),
					'sol' => esc_html__( 'sol', CodEntor_TD ),
					'solidity' => esc_html__( 'solidity', CodEntor_TD ),
					'solution-file' => esc_html__( 'solution-file', CodEntor_TD ),
					'soy' => esc_html__( 'soy', CodEntor_TD ),
					'sparql' => esc_html__( 'sparql', CodEntor_TD ),
					'splunk-spl' => esc_html__( 'splunk-spl', CodEntor_TD ),
					'sqf' => esc_html__( 'sqf', CodEntor_TD ),
					'sql' => esc_html__( 'sql', CodEntor_TD ),
					'ssml' => esc_html__( 'ssml', CodEntor_TD ),
					'stan' => esc_html__( 'stan', CodEntor_TD ),
					'stylus' => esc_html__( 'stylus', CodEntor_TD ),
					'svg' => esc_html__( 'svg', CodEntor_TD ),
					'swift' => esc_html__( 'swift', CodEntor_TD ),
					't4' => esc_html__( 't4', CodEntor_TD ),
					't4-cs' => esc_html__( 't4-cs', CodEntor_TD ),
					't4-templating' => esc_html__( 't4-templating', CodEntor_TD ),
					't4-vb' => esc_html__( 't4-vb', CodEntor_TD ),
					'tap' => esc_html__( 'tap', CodEntor_TD ),
					'tcl' => esc_html__( 'tcl', CodEntor_TD ),
					'tex' => esc_html__( 'tex', CodEntor_TD ),
					'textile' => esc_html__( 'textile', CodEntor_TD ),
					'toml' => esc_html__( 'toml', CodEntor_TD ),
					'trig' => esc_html__( 'trig', CodEntor_TD ),
					'ts' => esc_html__( 'ts', CodEntor_TD ),
					'tsconfig' => esc_html__( 'tsconfig', CodEntor_TD ),
					'tsx' => esc_html__( 'tsx', CodEntor_TD ),
					'tt2' => esc_html__( 'tt2', CodEntor_TD ),
					'turtle' => esc_html__( 'turtle', CodEntor_TD ),
					'twig' => esc_html__( 'twig', CodEntor_TD ),
					'typescript' => esc_html__( 'typescript', CodEntor_TD ),
					'typoscript' => esc_html__( 'typoscript', CodEntor_TD ),
					'uc' => esc_html__( 'uc', CodEntor_TD ),
					'unrealscript' => esc_html__( 'unrealscript', CodEntor_TD ),
					'uscript' => esc_html__( 'uscript', CodEntor_TD ),
					'vala' => esc_html__( 'vala', CodEntor_TD ),
					'vb' => esc_html__( 'vb', CodEntor_TD ),
					'vba' => esc_html__( 'vba', CodEntor_TD ),
					'vbnet' => esc_html__( 'vbnet', CodEntor_TD ),
					'velocity' => esc_html__( 'velocity', CodEntor_TD ),
					'verilog' => esc_html__( 'verilog', CodEntor_TD ),
					'vhdl' => esc_html__( 'vhdl', CodEntor_TD ),
					'vim' => esc_html__( 'vim', CodEntor_TD ),
					'visual-basic' => esc_html__( 'visual-basic', CodEntor_TD ),
					'warpscript' => esc_html__( 'warpscript', CodEntor_TD ),
					'wasm' => esc_html__( 'wasm', CodEntor_TD ),
					'webmanifest' => esc_html__( 'webmanifest', CodEntor_TD ),
					'wiki' => esc_html__( 'wiki', CodEntor_TD ),
					'xeora' => esc_html__( 'xeora', CodEntor_TD ),
					'xeoracube' => esc_html__( 'xeoracube', CodEntor_TD ),
					'xls' => esc_html__( 'xls', CodEntor_TD ),
					'xlsx' => esc_html__( 'xlsx', CodEntor_TD ),
					'xml' => esc_html__( 'xml', CodEntor_TD ),
					'xojo' => esc_html__( 'xojo', CodEntor_TD ),
					'xquery' => esc_html__( 'xquery', CodEntor_TD ),
					'yaml' => esc_html__( 'yaml', CodEntor_TD ),
					'yang' => esc_html__( 'yang', CodEntor_TD ),
					'yml' => esc_html__( 'yml', CodEntor_TD ),
					'zig' => esc_html__( 'zig', CodEntor_TD )
				],
				'default' => 'html'
			]
		);
		$this->add_control(
			'codentor_show_language',
			[
				'label' => esc_html__( 'Display Language', CodEntor_TD ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', CodEntor_TD ),
				'label_off' => esc_html__( 'Hide', CodEntor_TD ),
				'default' => esc_html__( 'yes' ),
			]
		);
		$this->add_control(
			'codentor_show_line_numbers',
			[
				'label' => esc_html__( 'Line Numbers', CodEntor_TD ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', CodEntor_TD ),
				'label_off' => esc_html__( 'Hide', CodEntor_TD ),
				'default' => esc_html__( 'yes' ),
			]
		);
		$this->add_control(
			'codentor_show_toolbar',
			[
				'label' => esc_html__( 'Copy to Clipboard', CodEntor_TD ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', CodEntor_TD ),
				'label_off' => esc_html__( 'Hide', CodEntor_TD ),
				'default' => __( 'yes' ),
			]
		);
		$this->add_responsive_control(
			'codentor_font_size',
			[
				'label' => esc_html__( 'Font Size', CodEntor_TD ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 100,
						'step' => 1,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .codentor_wrap code.language-html' => 'font-size: {{SIZE}}{{UNIT}} !important;',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_height',
			[
				'label' => esc_html__( 'Height', CodEntor_TD ),
				'type' => Controls_Manager::SLIDER,
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
				],
				'selectors' => [
					'{{WRAPPER}} pre.codentor_wrap.line-numbers.theme-default.language-html' => 'height: {{SIZE}}{{UNIT}} !important;',
				],
			]
		);
		$this->add_control(
			'codentor_content',
			[
				'label' => esc_html__( 'Code', CodEntor_TD ),
				'type' => Controls_Manager::CODE,
				'language' => 'text',
				'default' => '<h1>This is my language.</h1>',
				'rows' => 10,
			]
		);
		$this->end_controls_section();
		$this->start_controls_section(
			'codentor_catpost_content_style',
			[
				'label' => esc_html__( 'Code Syntex Style', CodEntor_TD ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);
		$this->add_control(
			'codentor_punctuation_color',
			[
				'label' => esc_html__( 'Punctuation Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.punctuation' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_comment_color',
			[
				'label' => esc_html__( 'Comment Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.comment' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_property_color',
			[
				'label' => esc_html__( 'Property Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.property' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_selector_color',
			[
				'label' => esc_html__( 'Selector Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.selector' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_operator_color',
			[
				'label' => esc_html__( 'Operator Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.operator' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_operator_bg_color',
			[
				'label' => esc_html__( 'Operator Background', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.operator' => 'background-color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_keyword_color',
			[
				'label' => esc_html__( 'Keyword Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.keyword' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_function_color',
			[
				'label' => esc_html__( 'Function Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.function' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_variable_color',
			[
				'label' => esc_html__( 'Variable Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} pre.theme-default .token.variable' => 'color: {{VALUE}}',
				],
			]
		);
		$this->end_controls_section();
		$this->start_controls_section(
			'codentor_catpost_title_style',
			[
				'label' => esc_html__( 'Line Numbers', CodEntor_TD ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'codentor_show_line_numbers' => 'yes'
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'codentor_title_typography',
				'selector' => '{{WRAPPER}} .line-numbers-rows span:before',
			]
		);
		$this->add_control(
			'codentor_title_color',
			[
				'label' => esc_html__( 'Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .line-numbers-rows span:before' => 'color: {{VALUE}} !important',
				],
			]
		);
		$this->add_control(
			'codentor_title_bg_color',
			[
				'label' => esc_html__( 'Background', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .line-numbers-rows' => 'background: {{VALUE}}',
				],
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'codentor_border_right',
				'label' => esc_html__( 'Right Border', CodEntor_TD ),
				'selector' => '{{WRAPPER}} .line-numbers-rows',
			]
		);
		$this->add_responsive_control(
			'codentor_titlee_border_radius',
			[
				'label' => esc_html__('Border Radius', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .line-numbers-rows span:before' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}} !important;',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_title_padding',
			[
				'label' => esc_html__('Padding', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .line-numbers-rows span:before' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_title_margin',
			[
				'label' => esc_html__('Margin', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .line-numbers-rows span:before' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->end_controls_section();

		$this->start_controls_section(
			'codentor_catpost_description_style',
			[
				'label' => esc_html__( 'Copy Clipboard', CodEntor_TD ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'codentor_show_toolbar' => 'yes',
				],
			]
		);
		// Hover control start for description
		$this->start_controls_tabs(
			'codentor_description_style_post'
		);
		$this->start_controls_tab(
			'codentor_description_normal_post',
			[
				'label' => esc_html__( 'Normal', CodEntor_TD ),
			]
		);
		// Normal Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'codentor_description_typography',
				'selector' => '{{WRAPPER}} .codentor_toolbar .toolbar-item button',
			]
		);
		$this->add_control(
			'codentor_description_color',
			[
				'label' => esc_html__( 'Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .codentor_toolbar .toolbar-item button' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_description_bg_color',
			[
				'label' => esc_html__( 'Background', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .codentor_toolbar .toolbar-item button' => 'background: {{VALUE}}',
				],
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'codentor_description_hover_tab',
			[
				'label' => esc_html__( 'Hover', CodEntor_TD ),
			]
		);
		// Hover Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'codentor_description_hover_typography',
				'selector' => '{{WRAPPER}} .codentor_toolbar .toolbar-item button:hover',
			]
		);
		$this->add_control(
			'codentor_description_hover_color',
			[
				'label' => esc_html__( 'Hover Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .codentor_toolbar .toolbar-item button:hover' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_description_hover_bg_color',
			[
				'label' => esc_html__( 'Background', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .codentor_toolbar .toolbar-item button:hover' => 'background: {{VALUE}}',
				],
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover Control End
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'codentor_copy_border',
				'label' => esc_html__( 'Border', CodEntor_TD ),
				'selector' => '{{WRAPPER}} .code-toolbar .codentor_toolbar .toolbar-item button',
				'separator' => 'before',
			]
		);
		$this->add_responsive_control(
			'codentor_desc_border_radius',
			[
				'label' => esc_html__('Border Radius', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .codentor_toolbar .toolbar-item button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}} !important;',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_desc_padding',
			[
				'label' => esc_html__('Padding', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .codentor_toolbar .toolbar-item button' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_desc_margin',
			[
				'label' => esc_html__('Margin', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .codentor_toolbar .toolbar-item button' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->end_controls_section();
		$this->start_controls_section(
			'codentor_language_btn_style',
			[
				'label' => esc_html__( 'Language Button', CodEntor_TD ),
				'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'codentor_show_language' => 'yes'
				],
			]
		);
		// Hover control start for description
		$this->start_controls_tabs(
			'codentor_language_style'
		);
		$this->start_controls_tab(
			'codentor_language_btn_normal',
			[
				'label' => esc_html__( 'Normal', CodEntor_TD ),
			]
		);
		// Normal Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'codentor_language_btn_typography',
				'selector' => '{{WRAPPER}} .code-toolbar div.codentor_language_type',
			]
		);
		$this->add_control(
			'codentor_language_btn_color',
			[
				'label' => esc_html__( 'Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .code-toolbar div.codentor_language_type' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_language_btn_bg_color',
			[
				'label' => esc_html__( 'Background', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .code-toolbar div.codentor_language_type' => 'background: {{VALUE}}',
				],
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'codentor_language_btn_hover_tab',
			[
				'label' => esc_html__( 'Hover', CodEntor_TD ),
			]
		);
		// Hover Controls
		$this->add_group_control(
			\Elementor\Group_Control_Typography::get_type(),
			[
				'name' => 'codentor_language_btn_hover_typography',
				'selector' => '{{WRAPPER}} .code-toolbar div.codentor_language_type:hover',
			]
		);
		$this->add_control(
			'codentor_language_btn_hover_color',
			[
				'label' => esc_html__( 'Hover Color', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .code-toolbar div.codentor_language_type:hover' => 'color: {{VALUE}}',
				],
			]
		);
		$this->add_control(
			'codentor_language_btn_hover_bg_color',
			[
				'label' => esc_html__( 'Background', CodEntor_TD ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .code-toolbar div.codentor_language_type:hover' => 'background: {{VALUE}}',
				],
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover Control End
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'codentor_language_btn_border',
				'label' => esc_html__( 'Border', CodEntor_TD ),
				'selector' => '{{WRAPPER}} .code-toolbar div.codentor_language_type',
				'separator' => 'before',
			]
		);
		$this->add_responsive_control(
			'codentor_language_btn_border_radius',
			[
				'label' => esc_html__('Border Radius', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .code-toolbar div.codentor_language_type' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}} !important;',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_language_btn_padding',
			[
				'label' => esc_html__('Padding', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .code-toolbar div.codentor_language_type' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_language_btn_margin',
			[
				'label' => esc_html__('Margin', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .code-toolbar div.codentor_language_type' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->end_controls_section();

		$this->start_controls_section(
			'codentor_content_style',
			[
				'label' => esc_html__( 'Background', CodEntor_TD ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);
		// Hover control start for box
		$this->start_controls_tabs(
			'codentor_box_style_post'
		);
		$this->start_controls_tab(
			'codentor_box_normal_post',
			[
				'label' => esc_html__( 'Normal', CodEntor_TD ),
			]
		);
		// Normal Controls
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'codentor_box_bg_grediant_color',
				'label' => esc_html__( 'Background', CodEntor_TD ),
				'types' => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .codentor_wrap',
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'codentor_box_boxshadow',
				'label' => esc_html__( 'Box Shadow', CodEntor_TD ),
				'selector' => '{{WRAPPER}} .codentor_wrap',
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'codentor_box_border',
				'label' => esc_html__( 'Border', CodEntor_TD ),
				'selector' => '{{WRAPPER}} .codentor_wrap',
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'codentor_box_hover_tab',
			[
				'label' => esc_html__( 'Hover', CodEntor_TD ),
			]
		);
		// Hover Controls
		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			[
				'name' => 'codentor_box_bg_grediant_color_hover',
				'label' => esc_html__( 'Background', CodEntor_TD ),
				'types' => [ 'classic', 'gradient', 'video' ],
				'selector' => '{{WRAPPER}} .codentor_wrap:hover',
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'codentor_box_boxshadow_hover',
				'label' => esc_html__( 'Box Shadow', CodEntor_TD ),
				'selector' => '{{WRAPPER}} .codentor_wrap:hover',
			]
		);
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'codentor_box_border_hover',
				'label' => esc_html__( 'Border', CodEntor_TD ),
				'selector' => '{{WRAPPER}} .codentor_wrap:hover',
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		// Hover Control End

		$this->add_responsive_control(
			'codentor_the_box_border_radius',
			[
				'label' => esc_html__('Border Radius', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'separator' => 'before',
				'size_units' => ['px', 'em', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .codentor_wrap' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_the_box_border_bottom',
			[
				'label' => esc_html__('Margin', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .codentor_wrap' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'codentor_box_padding',
			[
				'label' => esc_html__('Padding', CodEntor_TD),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => ['px', 'rem', '%'],
				'selectors' => [
					'{{WRAPPER}} .codentor_wrap' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->end_controls_section();
	}

	protected function render() {
		$display_all  = $this->get_settings_for_display();
		$codentor_language = $display_all ['codentor_language'];
		$codentor_theme = $display_all ['codentor_theme'];
		$codentor_show_line_numbers = $display_all ['codentor_show_line_numbers'];
		$codentor_show_toolbar = $display_all ['codentor_show_toolbar'];
		$codentor_content = htmlentities($display_all ['codentor_content']);
		$codentor_pre_classes = '';

		if('yes' === $codentor_show_line_numbers){
			$codentor_pre_classes .= "line-numbers ";
		}
		if('yes' !== $codentor_show_toolbar){
			$codentor_show_toolbar = "no";
		}
		$codentor_pre_classes .= "theme-" . preg_replace('/\s+/', '-', strtolower($codentor_theme));
		$codentor_language_check = $display_all['codentor_show_language']?'<div class="codentor_language_type">'.$codentor_language.'</div>':'';
		echo "<pre class='codentor_wrap $codentor_pre_classes' data-show-toolbar='$codentor_show_toolbar'>$codentor_language_check<code class='language-$codentor_language'>$codentor_content</code></pre>";	
		if( Plugin::instance()->editor->is_edit_mode()){
			$this->render_editor_script();
		}
	}

	protected function render_editor_script(){
		?><script type="text/javascript">
		jQuery( document ).ready(function(){
			window.Prism.highlightAll();
			jQuery('pre[data-show-toolbar="no"]').siblings('div.codentor_toolbar').hide();
		});
		</script>
		<?php
	}
}